#include <stdio.h>
#define MaxN 15

int main(int argc, char** argv)
{
	FILE *f;
	int n, m, k, s, u, v, i, j, *A, *B, *vrsta, glava, rep, *pred, *kako;
	/* Preberimo n, m in k ter alocirajmo pomnilnik. */
	f = fopen("strupi.in", "rt");
	fscanf(f, "%d %d %d", &n, &m, &k);
	A = (int *) malloc(sizeof(int) << n);
	B = (int *) malloc(sizeof(int) << n);
	vrsta = (int *) malloc(sizeof(int) << n); glava = rep = 0;
	kako = (int *) malloc(sizeof(int) << n);
	pred = (int *) malloc(sizeof(int) << n);
	for (i = 0; i < (1 << n); i++) pred[i] = -1;
	/* Preberimo mnoice A_i, B_i in zaetno stanje. */
	for (i = 0; i < m + k + 1; i++) {
		fscanf(f, "%d", &j);
		for(s = 0; j > 0; j--) {
			fscanf(f, "%d", &u);
			u -= 1; s |= 1 << u; }
		if (i < m) A[i] = s;
		else if (i < m + k) B[i - m] = s;
		else { vrsta[rep++] = s; pred[s] = s; }}
	fclose(f);

	/* Iskanje v irino (zaetno stanje imamo e v vrsti). */
	while (glava < rep && pred[0] < 0)
	{
		u = vrsta[glava++];
		for (i = 0; i < n; i++)
		{
			if ((u & (1 << i)) != 0) continue;
			/* Kaj se zgodi, e v stanje u dodamo strup i?
			   Mogoe pacient takoj umre. */
			v = u | (1 << i);
			for (j = 0; j < m; j++)
				if ((v & A[j]) == A[j]) { v = -1; break; }
			if (v < 0) continue;
			/* Mogoe pride do kaknih nevtralizacij. */
			for (j = 0; j < k; j++)
				if (((u | (1 << i)) & B[j]) == B[j]) v &= ~B[j];
			/* e novega stanja, v, e ne poznamo, ga dodajmo v vrsto. */
			if (pred[v] >= 0) continue;
			pred[v] = u; kako[v] = i;
			vrsta[rep++] = v;
			if (v == 0) break;
		}
	}

	/* Izpiimo rezultat. */
	f = fopen("strupi.out", "wt");
	if (pred[0] < 0) fprintf(f, "-1\n");
	else {
		/* S pomojo tabel kako in pred rekonstruirajmo
		   zaporedje dodajanja strupov. */
		u = 0; glava = 0;
		while (u != s) { vrsta[glava++] = kako[u]; u = pred[u]; }
		/* Na koncu zaporedja imamo strupe, ki smo jih dodali najprej;
		   zdaj torej izpiimo zaporedje od konca proti zaetku. */
		fprintf(f, "%d\n", glava);
		rep = glava; while (glava > 0) {
			if (glava < rep) fprintf(f, " ");
			fprintf(f, "%d", vrsta[--glava] + 1); }}
	fclose(f);

	/* Pospravimo za sabo. */
	free(A); free(B); free(vrsta); free(kako); free(pred); return 0;
}
