#include <iostream> /* RTK 2009.1.2 */
#include <iomanip>
#include <string>

using namespace std;

#define B 30
const char znaki[] = "0123456789ABCDEFGHJKMNPRTVWXYZ";

template<int n> class U
{
public:
	static void F(string s);
};

template<int n, int d> class U2
{
public:
	static void F(string s)
	{
		U2<n, d - 1>::F(s);
		U<n - 1>::F(s + znaki[d]);
	}
};

template<int n> class U2<n, -1>
{
public:
	static void F(string s) { }
};

template<int n> void U<n>::F(string s)
{
	U2<n, (B - 1)>::F(s);
}

template<> class U<0>
{
public:
	static void F(string s)
	{
		cout << s << endl;
	}
};

int main()
{
	U2<5, 23>::F("");
	U2<4, 19>::F(string(1, znaki[24]));
	U2<3, 21>::F(string(1, znaki[24]) + znaki[20]);
	U2<2, 5>::F(string(1, znaki[24]) + znaki[20] + znaki[22]);
	U2<1, 19>::F(string(1, znaki[24]) + znaki[20] + znaki[22] + znaki[6]);
	return 0;
}
