/* RTK 2009.3.2 */
#include <stdio.h>
#define MaxN 1000000
#define MaxM 2000000

int main(int argc, char** argv)
{
	FILE *f; int i, t, n, m, k, L, D, *levi, *desni, potopi;
	/* Preberimo tevilo lokvanjev. */
	f = fopen("zaba.in", "rt");
	fscanf(f, "%d %d %d", &n, &k, &m);
	/* Pripravimo tabeli, v katerih za vsak lokvanj pie,
	   kateri je najbliji nepotopljeni sosed v vsaki smeri. */
	levi = (int *) malloc(n * sizeof(int));
	desni = (int *) malloc(n * sizeof(int));
	for (t = 0; t < n; t++) {
		levi[t] = t - 1; desni[t] = t + 1; }
	/* Levo od prvega in desno od zadnjega lokvanja si mislimo
	   nek zelo oddaljen lokvanj, ki ga aba ne vidi. */
	levi[0] = -k - 1; desni[n - 1] = n + k;
	/* Berimo zaporedje skokov. */
	for (i = 0; i < m; i++)
	{
		fscanf(f, "%d %d", &t, &potopi); t -= 1;
		/* aba je na lokvanju t.  Katera sta najblija nepotopljena
		   soseda in ali ju aba e lahko vidi? */
		L = levi[t]; D = desni[t];
		if (L < t - k && D > t + k) break;
		/* e je treba, potopimo lokvanj t; L in D s tem postaneta
		   soseda drug drugemu. */
		if (potopi) {
			if (L >= 0) desni[L] = D;
			if (D < n) levi[D] = L; }
	}
	fclose(f);
	/* Izpiimo rezultat. */
	f = fopen("zaba.out", "wt");
	fprintf(f, "%d\n", (i == m ? 0 : t + 1)); fclose(f);
	/* Pospravimo za sabo. */
	free(levi); free(desni); return 0;
}
